diff --git a/bin/foamBinDirs b/bin/foamBinDirs
deleted file mode 100755
index 5922cf8628b5a3003bc916e8a243f5f7ec93773f..0000000000000000000000000000000000000000
--- a/bin/foamBinDirs
+++ /dev/null
@@ -1,61 +0,0 @@
-#!/bin/sh
-#---------------------------------*- sh -*-------------------------------------
-# =========                 |
-# \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
-#  \\    /   O peration     |
-#   \\  /    A nd           | Copyright (C) 1991-2010 OpenCFD Ltd.
-#    \\/     M anipulation  |
-#------------------------------------------------------------------------------
-# License
-#     This file is part of OpenFOAM.
-#
-#     OpenFOAM is free software: you can redistribute it and/or modify it
-#     under the terms of the GNU General Public License as published by
-#     the Free Software Foundation, either version 3 of the License, or
-#     (at your option) any later version.
-#
-#     OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
-#     ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
-#     FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
-#     for more details.
-#
-#     You should have received a copy of the GNU General Public License
-#     along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.
-#
-# Script
-#     foamBinDirs <packDir> <arch>
-#
-# Description
-#     Returns all directories containing binary files of OpenFOAM
-#
-#------------------------------------------------------------------------------
-
-if [ $# -ne 2 ]
-then
-    echo "Error: architecture type expected, exiting"
-    echo
-    echo "Usage : ${0##*/} <packDir> <arch>"
-    echo
-    exit 1
-fi
-packDir=$1
-arch=$2
-
-# base arch (w/o precision, optimization, etc)
-baseArch=$(echo "$arch" | sed -e 's@[DS]P.*$@@')
-
-# get list of directories
-(
-    for dir in \
-        $packDir/applications/bin/$arch \
-        $packDir/bin/$arch \
-        $packDir/lib/$arch \
-        $packDir/wmake/rules \
-        $packDir/wmake/bin/$baseArch \
-        ;
-    do
-        [ -d $dir ] && echo $dir
-    done
-)
-
-#------------------------------------------------------------------------------
diff --git a/bin/foamPack b/bin/foamPack
index 920bfaf52b1c5e64977b0fc1d05de413bb6f05d4..dd8dab951c47e5cf551fc0b2855555760783d584 100755
--- a/bin/foamPack
+++ b/bin/foamPack
@@ -1,9 +1,9 @@
 #!/bin/sh
-#---------------------------------*- sh -*-------------------------------------
+#------------------------------------------------------------------------------
 # =========                 |
 # \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
 #  \\    /   O peration     |
-#   \\  /    A nd           | Copyright (C) 1991-2010 OpenCFD Ltd.
+#   \\  /    A nd           | Copyright (C) 1991-2011 OpenCFD Ltd.
 #    \\/     M anipulation  |
 #------------------------------------------------------------------------------
 # License
@@ -23,47 +23,102 @@
 #     along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.
 #
 # Script
-#     foamPack [outputDir]
+#     foamPack [OPTION]
 #
 # Description
-#     Packs and compresses the OpenFOAM directory for release
+#     Pack and compress the OpenFOAM directory for release
 #
 #------------------------------------------------------------------------------
-
-timeStamp=$(date +%Y-%m-%d)
 packDir=$WM_PROJECT-$WM_PROJECT_VERSION
-packFile=${packDir}_${timeStamp}.gtgz
+toolsDir="${0%/*}/tools"  # this script is located in the tools/ parent dir
 
-if [ ! -d $packDir ]
-then
-    echo "Error: directory $packDir does not exist"
+usage() {
+    while [ $# -gt 0 ]; do echo "$1" 1>&2; shift; done
+cat <<USAGE 1>&2
+Usage: ${0##*/} [OPTION]
+options:
+  -o <dir>          specify alternative output directory
+  -nogit            bypass using 'git archive'
+
+* Pack and compress OpenFOAM directory for release
+
+USAGE
     exit 1
-fi
+}
+
+unset prefix outputDir nogit
+# parse options
+while [ "$#" -gt 0 ]
+do
+    case "$1" in
+    -h | -help)
+        usage
+        ;;
+    -nogit)
+        nogit=true
+        shift
+        ;;
+    -o | -output)
+        [ "$#" -ge 2 ] || usage "'$1' option requires an argument"
+        outputDir=${2%%/}
+        shift 2
+        ;;
+    -*)
+        usage "unknown option: '$*'"
+        ;;
+    *)
+        break
+        ;;
+    esac
+done
+
+# check for essential directories
+for dir in $packDir
+do
+    [ -d $dir ] || {
+        echo "Error: directory $dir does not exist" 1>&2
+        exit 1
+    }
+done
+
+
+#------------------------------------------------------------------------------
+timeStamp=$(date +%Y-%m-%d)
+packExt=tgz
+packBase=${packDir}_${timeStamp}
 
 # add optional output directory
-if [ -d "$1" ]
-then
-    packFile="$1/$packFile"
-fi
+[ -d "$outputDir" ] && packBase="$outputDir/$packBase"
+packFile=$packBase.$packExt
 
+# avoid overwriting old pack file
 if [ -f $packFile ]
 then
-    echo "Error: $packFile already exists"
+    echo "Error: $packFile already exists" 1>&2
     exit 1
 fi
 
-# Create time stamp file
-# ~~~~~~~~~~~~~~~~~~~~~~
-
+# add time-stamp file before packing
 echo $timeStamp 2>/dev/null > $packDir/.timeStamp
 
-# Pack and compress the packFile
-# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+# check for git (program and .git directory)
+(cd $packDir && git branch) > /dev/null 2>&1 || nogit=true
+
+if [ "$nogit" = true ]
+then
+    echo "pack manually" 1>&2
+    $toolsDir/foamPackSource $packDir $packFile
+else
+    echo "pack with git-archive" 1>&2
+    ( cd $packDir && git archive --format=tar --prefix=$packDir/ HEAD) > $packBase.tar
 
-echo
-echo "Packing $packDir source files into $packFile"
-echo
+    echo "add in time-stamp and lnInclude directories" 1>&2
+    tar cf $packBase.tar2 $packDir/.timeStamp $packDir/.build `find -H $packDir -type d -name lnInclude`
+    tar Af $packBase.tar $packBase.tar2
 
-foamPackSource $packDir $packFile
+    echo "gzip tar file" 1>&2
+    gzip -c9 $packBase.tar > $packFile
+    rm -f $packBase.tar $packBase.tar2 2>/dev/null
+fi
 
 #------------------------------------------------------------------------------
diff --git a/bin/foamPackBin b/bin/foamPackBin
index 251691d0dd45fba58833b2996a050d42750bf576..fa0fb00150940e0840182eb8f27ee588e0ab1bc8 100755
--- a/bin/foamPackBin
+++ b/bin/foamPackBin
@@ -3,7 +3,7 @@
 # =========                 |
 # \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
 #  \\    /   O peration     |
-#   \\  /    A nd           | Copyright (C) 1991-2010 OpenCFD Ltd.
+#   \\  /    A nd           | Copyright (C) 1991-2011 OpenCFD Ltd.
 #    \\/     M anipulation  |
 #-------------------------------------------------------------------------------
 # License
@@ -23,74 +23,119 @@
 #     along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.
 #
 # Script
-#     foamPackBin <arch> [outputDir]
+#     foamPackBin [OPTION] <archOptions>
 #
 # Description
-#     Packs and compresses binary version of OpenFOAM for release
+#     Pack and compress binary version of OpenFOAM for release
+#
+# Script
+#     foamPackThirdPartyBin [OPTION] <archOptions>
+#
+# Description
+#     Pack and compress binary version of OpenFOAM ThirdParty for release
 #
 #------------------------------------------------------------------------------
+toolsDir="${0%/*}/tools"  # this script is located in the tools/ parent dir
 
-if [ $# -eq 0 ]
-then
-    echo "Error: architecture type expected, exiting"
-    echo
-    echo "Usage : ${0##*/} <arch> [outputDir]"
-    echo
+case "${0##*/}" in
+*ThirdParty*)
+    # for ThirdParty
+    codeBase="OpenFOAM ThirdParty"
+    packDir=ThirdParty-$WM_PROJECT_VERSION
+    listBinDirs=$toolsDir/foamListThirdPartyBinDirs
+    ;;
+*)
+    # regular
+    codeBase="OpenFOAM ThirdParty"
+    packDir=$WM_PROJECT-$WM_PROJECT_VERSION
+    listBinDirs=$toolsDir/foamListBinDirs
+    ;;
+esac
+
+
+usage() {
+    while [ $# -gt 0 ]; do echo "$1" 1>&2; shift; done
+cat <<USAGE 1>&2
+Usage: ${0##*/} [OPTION] <archOptions>
+options:
+  -o <dir>          specify alternative output directory
+
+* Pack and compress binary version of $codeBase for release
+
+    The value of 'archOptions' normally corresponds to \$WM_OPTIONS
+    The current value of \$WM_OPTIONS = $WM_OPTIONS
+
+USAGE
     exit 1
-fi
-arch=$1
+}
+
+
+unset prefix outputDir
+# parse options
+while [ "$#" -gt 0 ]
+do
+    case "$1" in
+    -h | -help)
+        usage
+        ;;
+    -o | -output)
+        [ "$#" -ge 2 ] || usage "'$1' option requires an argument"
+        outputDir=${2%%/}
+        shift 2
+        ;;
+    -*)
+        usage "unknown option: '$*'"
+        ;;
+    *)
+        break
+        ;;
+    esac
+done
+
+[ $# -eq 1 ] || usage "Error: specify architecture"
 
-# base arch (w/o precision, optimization, etc)
-baseArch=$(echo "$arch" | sed -e 's@[DS]P.*$@@')
+# same as $WM_OPTIONS - eg, 'linux64GccDPOpt'
+archOptions="$1"
 
+#------------------------------------------------------------------------------
 timeStamp=$(date +%Y-%m-%d)
-packDir=$WM_PROJECT-$WM_PROJECT_VERSION
-packFile=${packDir}.${arch}_${timeStamp}.gtgz
+packExt=tgz
+packBase=${packDir}.${archOptions}_${timeStamp}
 
 # add optional output directory
-if [ -d "$2" ]
-then
-    packFile="$2/$packFile"
-fi
+[ -d "$outputDir" ] && packBase="$outputDir/$packBase"
+packFile=$packBase.$packExt
 
+# avoid overwriting old pack file
 if [ -f $packFile ]
 then
-    echo "Error: $packFile already exists"
+    echo "Error: $packFile already exists" 1>&2
     exit 1
 fi
 
-# check for essential directories
-for dir in $packDir $packDir/lib/$arch
-do
-    [ -d $dir ] || {
-        echo "Error: directory $dir does not exist"
-        exit 1
-    }
-done
-
-# this changed - check for either
-[ -d $packDir/bin/$arch -o -d $packDir/applications/bin/$arch ] || {
-    echo "Error: one of these directories must exist:"
-    echo "    $packDir/bin/$archdir"
-    echo "    $packDir/applications/bin/$archdir"
-    exit 1
-}
 
+#------------------------------------------------------------------------------
 
 # get list of directories
-dirList=`foamBinDirs $packDir $arch`
+dirList=$( $listBinDirs $packDir $archOptions )
+if [ $? -eq 0 -a -n "$dirList" ]
+then
+    echo "Pack into $packFile" 1>&2
+    echo 1>&2
+else
+    exit 1
+fi
 
-echo
-echo "Packing $arch ($baseArch) port of $packDir into $packFile"
-echo
 
-tar czpf $packFile $dirList
+# Clean up on Ctrl-C
+trap 'rm -f $packFile 2>/dev/null' INT
 
+tar cpzf $packFile $dirList
 if [ $? -eq 0 ]
 then
-    echo "Finished packing and compressing file $packFile"
+    echo "Finished packing file $packFile" 1>&2
 else
-    echo "Error: failure packing $packFile"
+    echo "Error: failure packing $packFile" 1>&2
     rm -f $packFile 2>/dev/null
 fi
 
diff --git a/bin/foamPackBinAll b/bin/foamPackBinAll
index ce16058b64f26882261486dcc310b882c2881706..8d56e5701f150107f93e8ea0c8176df02a3e76ad 100755
--- a/bin/foamPackBinAll
+++ b/bin/foamPackBinAll
@@ -3,7 +3,7 @@
 # =========                 |
 # \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
 #  \\    /   O peration     |
-#   \\  /    A nd           | Copyright (C) 1991-2010 OpenCFD Ltd.
+#   \\  /    A nd           | Copyright (C) 1991-2011 OpenCFD Ltd.
 #    \\/     M anipulation  |
 #-------------------------------------------------------------------------------
 # License
@@ -23,24 +23,44 @@
 #     along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.
 #
 # Script
-#     foamPackBinAll [outputDir]
+#     foamPackBinAll [OPTION]
 #
 # Description
-#     Packs and compresses all binary versions of foam for release
+#     Pack and compress all binary versions of OpenFOAM for release
+#
+# Script
+#     foamPackThirdPartyBinAll [OPTION]
+#
+# Description
+#     Pack and compress all binary versions of OpenFOAM ThirdParty for release
 #
 #------------------------------------------------------------------------------
-packDir=$WM_PROJECT-$WM_PROJECT_VERSION
+binDir="${0%/*}"  # this script is located in the bin/ dir
 
-if [ ! -d $packDir ]
-then
-    echo "Error: directory $packDir does not exist"
+case "${0##*/}" in
+*ThirdParty*)
+    # for ThirdParty
+    packDir=ThirdParty-$WM_PROJECT_VERSION
+    packBin=foamPackThirdPartyBin
+    ;;
+*)
+    # regular
+    packDir=$WM_PROJECT-$WM_PROJECT_VERSION
+    packBin=foamPackBin
+    ;;
+esac
+
+
+[ -d $packDir ] || {
+    echo "Error: directory $packDir does not exist" 1>&2
     exit 1
-fi
+}
+
 
-# obtain arch types from lib/
-for bin in $packDir/lib/*
+# obtain archOptions types from lib/
+for archOptions in $packDir/lib/*
 do
-    foamPackBin ${bin##*/} $@
+    $binDir/$packBin $@ ${archOptions##*/}
 done
 
 #------------------------------------------------------------------------------
diff --git a/bin/foamPackDoxygen b/bin/foamPackDoxygen
index f93e41cd6df9212508b53cb45d957efdefaf8c42..c9337e972f4ce3a9262087f42d5e5947eb397670 100755
--- a/bin/foamPackDoxygen
+++ b/bin/foamPackDoxygen
@@ -3,7 +3,7 @@
 # =========                 |
 # \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
 #  \\    /   O peration     |
-#   \\  /    A nd           | Copyright (C) 1991-2010 OpenCFD Ltd.
+#   \\  /    A nd           | Copyright (C) 2008-2011 OpenCFD Ltd.
 #    \\/     M anipulation  |
 #-------------------------------------------------------------------------------
 # License
@@ -26,39 +26,44 @@
 #     foamPackDoxygen [-prefix DIR] [-o outputDir]
 #
 # Description
-#     Packs and compresses the OpenFOAM doxygen html for release
+#     Pack and compress the OpenFOAM doxygen html for release
 #
 #------------------------------------------------------------------------------
 packDir=$WM_PROJECT-$WM_PROJECT_VERSION
-packTag=_Doxygen.gtgz
+htmlDir=doc/Doxygen/html
 
 usage() {
     while [ $# -gt 0 ]; do echo "$1" 1>&2; shift; done
 cat <<USAGE 1>&2
-Usage: ${0##*/} [-prefix DIR] [-o outputDir]
+Usage: ${0##*/} [OPTION]
+options:
+  -prefix <dir>     use alternative prefix
+  -o <dir>          specify alternative output directory
 
-    Packs and compresses the OpenFOAM doxygen html for release
+* Pack and compress the OpenFOAM doxygen html for release
 
 USAGE
     exit 1
 }
 
 unset prefix outputDir
-
+# parse options
 while [ "$#" -gt 0 ]
 do
     case $1 in
-    -prefix | --prefix )
+    -h | -help)
+        usage
+        ;;
+    -prefix | --prefix)
+        [ "$#" -ge 2 ] || usage "'$1' option requires an argument"
         prefix=${2%%/}
         shift 2
         ;;
-    -o | -output )
+    -o | -output)
+        [ "$#" -ge 2 ] || usage "'$1' option requires an argument"
         outputDir=${2%%/}
         shift 2
         ;;
-    -h | -help )
-        usage
-        ;;
     -*)
         usage "unknown option: '$*'"
         ;;
@@ -81,41 +86,44 @@ then
     exit 1
 fi
 
-#
+#------------------------------------------------------------------------------
+packExt=tgz
+packName=${packDir}_Doxygen
+
 # add optional output directory
-#
-if [ -d "$outputDir" ]
-then
-    packFile="$outputDir/$packDir$packTag"
-else
-    packFile="$packDir$packTag"
-fi
+[ -d "$outputDir" ] && packName="$outputDir/$packName"
+packFile=$packName.$packExt
 
 
 if [ -f $packFile ]
 then
-    echo "Error: $packFile already exists"
+    echo "Error: $packFile already exists" 1>&2
     exit 1
 fi
 
-# Pack and compress the packFile using GNU tar
-# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-echo
-echo "Packing doxygen html into $packFile"
-echo
+cat <<INFO 1>&2
+-------------------------------------------------------------------------------
+Packing doxygen html into $packFile
+
+INFO
+
+# Clean up on Ctrl-C
+trap 'rm -f $packFile 2>/dev/null' INT
 
 if [ -n "$prefix" ]
 then
-    tar czpf $packFile --transform="s@^@$prefix/@" doc/Doxygen/html
+    # requires GNU tar
+    tar cpzf $packFile --transform="s@^@$prefix/@" $htmlDir
 else
-    tar czpf $packFile $packDir/doc/Doxygen/html
+    tar cpzf $packFile $packDir/$htmlDir
 fi
 
 if [ $? -eq 0 ]
 then
-    echo "Finished packing doxygen html into file $packFile"
+    echo "Finished packing doxygen html into file $packFile" 1>&2
 else
-    echo "Error: failure packing doxygen html file $packFile"
+    echo "Error: failure packing doxygen html file $packFile" 1>&2
+    rm -f $packFile 2>/dev/null
 fi
 
 #------------------------------------------------------------------------------
diff --git a/bin/foamPackThirdParty b/bin/foamPackThirdParty
index 4cd5b9c9ee6dd2bb4885a96f46b303e475d3866c..e0f07178d74e541a8a5e06339479f5b7e49b72c9 100755
--- a/bin/foamPackThirdParty
+++ b/bin/foamPackThirdParty
@@ -1,9 +1,9 @@
 #!/bin/sh
-#---------------------------------*- sh -*-------------------------------------
+#------------------------------------------------------------------------------
 # =========                 |
 # \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
 #  \\    /   O peration     |
-#   \\  /    A nd           | Copyright (C) 1991-2010 OpenCFD Ltd.
+#   \\  /    A nd           | Copyright (C) 2008-2011 OpenCFD Ltd.
 #    \\/     M anipulation  |
 #------------------------------------------------------------------------------
 # License
@@ -23,48 +23,86 @@
 #     along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.
 #
 # Script
-#     foamPackThirdParty [outputDir]
+#     foamPackThirdParty [OPTION]
 #
 # Description
-#     Packs and compresses the OpenFOAM ThirdParty directory for release
+#     Pack and compress the OpenFOAM ThirdParty directory for release
 #
 #------------------------------------------------------------------------------
+packDir=ThirdParty-$WM_PROJECT_VERSION
+toolsDir="${0%/*}/tools"  # this script is located in the tools/ parent dir
 
-timeStamp=$(date +%Y-%m-%d)
-packDir=${WM_THIRD_PARTY_DIR:-ThirdParty}
-packDir=${packDir##*/}
-packFile=${packDir}_${timeStamp}.gtgz
+usage() {
+    while [ $# -gt 0 ]; do echo "$1" 1>&2; shift; done
+cat <<USAGE 1>&2
+Usage: ${0##*/} [OPTION]
+options:
+  -o <dir>          specify alternative output directory
 
-if [ ! -d $packDir ]
-then
-    echo "Error: directory $packDir does not exist"
+* Pack and compress ThirdParty directory for release
+
+USAGE
     exit 1
-fi
+}
+
+unset prefix outputDir nogit
+# parse options
+while [ "$#" -gt 0 ]
+do
+    case "$1" in
+    -h | -help)
+        usage
+        ;;
+    -nogit)
+        nogit=true
+        shift
+        ;;
+    -o | -output)
+        [ "$#" -ge 2 ] || usage "'$1' option requires an argument"
+        outputDir=${2%%/}
+        shift 2
+        ;;
+    -*)
+        usage "unknown option: '$*'"
+        ;;
+    *)
+        break
+        ;;
+    esac
+done
+
+# check for essential directories
+for dir in $packDir
+do
+    [ -d $dir ] || {
+        echo "Error: directory $dir does not exist" 1>&2
+        exit 1
+    }
+done
+
+
+#------------------------------------------------------------------------------
+timeStamp=$(date +%Y-%m-%d)
+packExt=tgz
+packBase=${packDir}_${timeStamp}
 
 # add optional output directory
-if [ -d "$1" ]
-then
-    packFile="$1/$packFile"
-fi
+[ -d "$outputDir" ] && packBase="$outputDir/$packBase"
+packFile=$packBase.$packExt
 
+# avoid overwriting old pack file
 if [ -f $packFile ]
 then
     echo "Error: $packFile already exists"
     exit 1
 fi
 
-# Create time stamp file
-# ~~~~~~~~~~~~~~~~~~~~~~
 
-echo $timeStamp 2>/dev/null > $packDir/.timeStamp
-
-# Pack and compress the packFile
-# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-
-echo
-echo "Packing $packDir source files into $packFile"
-echo
+#------------------------------------------------------------------------------
 
-foamPackSource $packDir $packFile
+# add time-stamp file before packing
+echo $timeStamp 2>/dev/null > $packDir/.timeStamp
+echo "pack manually" 1>&2
+$toolsDir/foamPackSource $packDir $packFile
 
 #------------------------------------------------------------------------------
diff --git a/bin/foamPackThirdPartyBin b/bin/foamPackThirdPartyBin
deleted file mode 100755
index 8e478ddcd49b948aae6a134e9deaae71e65ffbf0..0000000000000000000000000000000000000000
--- a/bin/foamPackThirdPartyBin
+++ /dev/null
@@ -1,88 +0,0 @@
-#!/bin/sh
-#------------------------------------------------------------------------------
-# =========                 |
-# \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
-#  \\    /   O peration     |
-#   \\  /    A nd           | Copyright (C) 1991-2010 OpenCFD Ltd.
-#    \\/     M anipulation  |
-#-------------------------------------------------------------------------------
-# License
-#     This file is part of OpenFOAM.
-#
-#     OpenFOAM is free software: you can redistribute it and/or modify it
-#     under the terms of the GNU General Public License as published by
-#     the Free Software Foundation, either version 3 of the License, or
-#     (at your option) any later version.
-#
-#     OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
-#     ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
-#     FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
-#     for more details.
-#
-#     You should have received a copy of the GNU General Public License
-#     along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.
-#
-# Script
-#     foamPackThirdPartyBin <archOptions> [outputDir]
-#
-# Description
-#     Packs and compresses binary version of OpenFOAM ThirdParty for release
-#
-#------------------------------------------------------------------------------
-
-if [ $# -eq 0 ]
-then
-    echo "Error: archOptions type expected, exiting"
-    echo
-    echo "Usage : ${0##*/} <archOptions> [outputDir]"
-    echo
-    exit 1
-fi
-archOptions=$1
-arch=${archOptions%%G*}  # TODO: works for Gcc only
-arch3264=$(echo "$arch" | sed -e 's@64@-64@')
-
-echo "archOptions=$archOptions"
-echo "arch=$arch"
-echo "arch3264=$arch3264"
-
-timeStamp=$(date +%Y-%m-%d)
-packDir=${WM_THIRD_PARTY_DIR:-ThirdParty}
-packDir=${packDir##*/}
-packFile=${packDir}.${archOptions}_${timeStamp}.gtgz
-
-if [ ! -d $packDir ]
-then
-    echo "Error: directory $packDir does not exist"
-    exit 1
-fi
-
-# add optional output directory
-if [ -d "$2" ]
-then
-    packFile="$2/$packFile"
-fi
-
-if [ -f $packFile ]
-then
-    echo "Error: $packFile already exists"
-    exit 1
-fi
-
-# get list of directories
-dirList=`find $packDir -type d -name $arch -o -type d -name $archOptions'*' -o -type l -name $arch3264`
-echo
-echo "Packing $archOptions port of $packDir into $packFile"
-echo
-
-tar czpf $packFile $dirList
-
-if [ $? -eq 0 ]
-then
-    echo "Finished packing and compressing file $packFile"
-else
-    echo "Error: failure packing $packFile"
-    rm -f $packFile 2>/dev/null
-fi
-
-#------------------------------------------------------------------------------
diff --git a/bin/foamPackThirdPartyBin b/bin/foamPackThirdPartyBin
new file mode 120000
index 0000000000000000000000000000000000000000..4841836eb6bbfc8fc3a822e242ee8974357770e9
--- /dev/null
+++ b/bin/foamPackThirdPartyBin
@@ -0,0 +1 @@
+foamPackBin
\ No newline at end of file
diff --git a/bin/foamPackThirdPartyBinAll b/bin/foamPackThirdPartyBinAll
new file mode 120000
index 0000000000000000000000000000000000000000..d37f60a48ac388b34e6eb1f4b31e885f7205b79e
--- /dev/null
+++ b/bin/foamPackThirdPartyBinAll
@@ -0,0 +1 @@
+foamPackBinAll
\ No newline at end of file
diff --git a/bin/foamSourceFiles b/bin/foamSourceFiles
deleted file mode 100755
index 267a86ecbcf6cc0102fb0951be150a7b72996a85..0000000000000000000000000000000000000000
--- a/bin/foamSourceFiles
+++ /dev/null
@@ -1,88 +0,0 @@
-#!/bin/sh
-#---------------------------------*- sh -*-------------------------------------
-# =========                 |
-# \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
-#  \\    /   O peration     |
-#   \\  /    A nd           | Copyright (C) 1991-2010 OpenCFD Ltd.
-#    \\/     M anipulation  |
-#------------------------------------------------------------------------------
-# License
-#     This file is part of OpenFOAM.
-#
-#     OpenFOAM is free software: you can redistribute it and/or modify it
-#     under the terms of the GNU General Public License as published by
-#     the Free Software Foundation, either version 3 of the License, or
-#     (at your option) any later version.
-#
-#     OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
-#     ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
-#     FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
-#     for more details.
-#
-#     You should have received a copy of the GNU General Public License
-#     along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.
-#
-# Script
-#     foamSourceFiles <directory>
-#
-# Description
-#     Returns all the .C and .H files and Make/options
-#     and Make/files in a given directory.
-#
-#------------------------------------------------------------------------------
-
-if [ $# -ne 1 ]
-then
-    echo "Usage : ${0##*/} directory"
-    echo ""
-    echo "Returns all .C and .H files and Make/options and Make/files."
-    echo ""
-    exit 1
-fi
-
-# canonical form (no double and no trailing dashes)
-packDir=$(echo "$1" | sed -e 's@//*@/@g' -e 's@/$@@')
-
-if [ ! -d $packDir ]
-then
-    echo "Error: directory $packDir does not exist"
-    exit 1
-fi
-
-#
-# special handling for the bin/ directory:
-# allow through bin/tools sub-directory, but filter out others
-# which are likely architecture-specific binaries
-#
-
-find -H $packDir               \
-    ! -type d                  \
-   \( -type f -o -type l \)    \
-    ! -name "*~"               \
- -a ! -name ".*~"              \
- -a ! -name "*.orig"           \
- -a ! -name "*.dep"            \
- -a ! -name "*.o"              \
- -a ! -name "*.so"             \
- -a ! -name "*.a"              \
- -a ! -name "*.tgz"            \
- -a ! -name "core"             \
- -a ! -name "core.[1-9]*"      \
- -a ! -name "libccmio*"        \
-| sed                          \
- -e "\@$packDir/lib/@d"        \
- -e '\@/\.git/@d'              \
- -e '\@/\.gitignore@d'         \
- -e '\@/\.tags/@d'             \
- -e '\@/\README\.org@d'        \
- -e '\@applications/bin/@d'    \
- -e '\@bin/.*/@{\@bin/tools@!d}' \
- -e '\@wmake/bin/.*/@{\@wmake/bin/tools@!d}' \
- -e '\@/t/@d'                  \
- -e '\@/Make[.A-Za-z]*/[^/]*/@d'\
- -e '\@/platforms/@d'          \
- -e '\@/download/@d'           \
- -e '\@/libccmio-.*/@d'        \
- -e '\@/debian/@d'
-
-#------------------------------------------------------------------------------
diff --git a/bin/tools/CleanFunctions b/bin/tools/CleanFunctions
index bc5c81e94de6bf06f94a4b563d493903637cae7d..11185647041334e3235e0b50c6f4341ab620726d 100644
--- a/bin/tools/CleanFunctions
+++ b/bin/tools/CleanFunctions
@@ -2,7 +2,7 @@
 # =========                 |
 # \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
 #  \\    /   O peration     |
-#   \\  /    A nd           | Copyright (C) 1991-2010 OpenCFD Ltd.
+#   \\  /    A nd           | Copyright (C) 2008-2011 OpenCFD Ltd.
 #    \\/     M anipulation  |
 #------------------------------------------------------------------------------
 # License
@@ -25,7 +25,7 @@
 #     CleanFunctions
 #
 # Description
-#
+#     Miscellaneous cleanup functions for tutorial cases
 #------------------------------------------------------------------------------
 
 #cleanTimeDirectories()
@@ -46,15 +46,12 @@
 cleanTimeDirectories()
 {
     echo "Cleaning $PWD case"
-    nZeros=0
     zeros=""
-    while [ $nZeros -lt 8 ]
+    while [ ${#zeros} -lt 8 ]
     do
         timeDir="0.${zeros}[1-9]*"
-        rm -rf ${timeDir} > /dev/null 2>&1
-        rm -rf ./-${timeDir} > /dev/null 2>&1
-        zeros=`printf %0${nZeros}d 0`
-        nZeros=$(($nZeros + 1))
+        rm -rf ./${timeDir} ./-${timeDir} > /dev/null 2>&1
+        zeros="0$zeros"
     done
     rm -rf ./[1-9]* ./-[1-9]* ./log ./log.* ./log-* ./logSummary.* ./.fxLock ./*.xml ./ParaView* ./paraFoam* ./*.OpenFOAM > /dev/null 2>&1
 }
diff --git a/bin/tools/RunFunctions b/bin/tools/RunFunctions
index 20a9cd080c10cc036be9a38fbe24b7543808e55c..bfaf58c39caf1b825d8e2b1b0a87c79a338d3031 100644
--- a/bin/tools/RunFunctions
+++ b/bin/tools/RunFunctions
@@ -2,7 +2,7 @@
 # =========                 |
 # \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
 #  \\    /   O peration     |
-#   \\  /    A nd           | Copyright (C) 1991-2010 OpenCFD Ltd.
+#   \\  /    A nd           | Copyright (C) 2008-2011 OpenCFD Ltd.
 #    \\/     M anipulation  |
 #------------------------------------------------------------------------------
 # License
@@ -25,23 +25,23 @@
 #     RunFunctions
 #
 # Description
-#
+#     Miscellaneous functions for running tutorial cases
 #------------------------------------------------------------------------------
 
 getApplication()
 {
-    grep application system/controlDict | sed "s/application *\([a-zA-Z]*\);/\1/"
+    sed -ne 's/^ *application *\([a-zA-Z]*\) *;.*$/\1/p' system/controlDict
 }
 
 runApplication()
 {
     APP_RUN=$1
+    APP_NAME=${1##*/}
     shift
-    APP_NAME=${APP_RUN##*/}
 
     if [ -f log.$APP_NAME ]
     then
-        echo "$APP_NAME already run on $PWD: remove log file to run"
+        echo "$APP_NAME already run on $PWD: remove log file to re-run"
     else
         echo "Running $APP_RUN on $PWD"
         $APP_RUN $* > log.$APP_NAME 2>&1
@@ -51,16 +51,17 @@ runApplication()
 runParallel()
 {
     APP_RUN=$1
+    APP_NAME=${1##*/}
     shift
 
-    if [ -f $log.$APP_RUN ]
+    if [ -f log.$APP_NAME ]
     then
-        echo "$APP_RUN already run on $PWD: remove log file to run"
+        echo "$APP_NAME already run on $PWD: remove log file to re-run"
     else
         nProcs=$1
         shift
         echo "Running $APP_RUN in parallel on $PWD using $nProcs processes"
-        ( mpirun -np $nProcs $APP_RUN -parallel $* < /dev/null > log.$APP_RUN 2>&1 )
+        ( mpirun -np $nProcs $APP_RUN -parallel $* < /dev/null > log.$APP_NAME 2>&1 )
     fi
 }
 
diff --git a/bin/tools/foamListBinDirs b/bin/tools/foamListBinDirs
new file mode 100755
index 0000000000000000000000000000000000000000..ac67b796d045e05bd34ead416cc1f2b64ed1ce4f
--- /dev/null
+++ b/bin/tools/foamListBinDirs
@@ -0,0 +1,121 @@
+#!/bin/sh
+#------------------------------------------------------------------------------
+# =========                 |
+# \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
+#  \\    /   O peration     |
+#   \\  /    A nd           | Copyright (C) 1991-2011 OpenCFD Ltd.
+#    \\/     M anipulation  |
+#-------------------------------------------------------------------------------
+# License
+#     This file is part of OpenFOAM.
+#
+#     OpenFOAM is free software: you can redistribute it and/or modify it
+#     under the terms of the GNU General Public License as published by
+#     the Free Software Foundation, either version 3 of the License, or
+#     (at your option) any later version.
+#
+#     OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
+#     ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+#     FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+#     for more details.
+#
+#     You should have received a copy of the GNU General Public License
+#     along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.
+#
+# Script
+#     foamListBinDirs <directory> <archOptions>
+#
+# Description
+#     Lists directories containing binary files of OpenFOAM
+#
+# Note
+#     Not normally called directly by the user.
+#------------------------------------------------------------------------------
+toolsDir="${0%/*}"  # this script is already located in the tools/ directory
+
+[ $# -eq 2 ] || {
+cat <<USAGE 1>&2
+Usage : ${0##*/} <packDir> <archOptions>
+
+* Lists directories containing binary files for OpenFOAM
+
+    The value of 'archOptions' normally corresponds to \$WM_OPTIONS
+    The current value of \$WM_OPTIONS = $WM_OPTIONS
+
+USAGE
+    exit 1
+}
+
+#------------------------------------------------------------------------------
+packDir="$1"
+
+# same as $WM_OPTIONS - eg, 'linux64GccDPOpt'
+archOptions="$2"
+
+# base arch (w/o precision, optimization, etc)
+# same as "$WM_ARCH$WM_COMPILER"
+archCompiler=$(echo "$archOptions" | sed -e 's@[DS]P.*$@@')
+
+# same as $WM_ARCH - eg, 'linux64'
+# TODO: only works for Gcc, Icc, Clang
+archOS=$(echo "$archOptions" | sed -e 's@[GI]cc.*$@@' -e 's@Clang.*$@@')
+
+# links for 32-bit version, eg convert linux64 -> linux-64
+arch3264=$(echo "$archOS" | sed -e 's@64@-64@')
+
+
+#------------------------------------------------------------------------------
+
+# check for essential directories
+for dir in $packDir $packDir/lib/$archOptions
+do
+    [ -d $dir ] || {
+        echo "Error: directory $dir does not exist" 1>&2
+        exit 1
+    }
+done
+
+# check new/old places for executables - same as $FOAM_APPBIN
+[ -d $packDir/bin/$archOptions -o -d $packDir/applications/bin/$archOptions ] || {
+cat <<BIN_CHECK 1>&2
+Error: no directory for executables exists:
+    $packDir/bin/$archOptions
+    $packDir/applications/bin/$archOptions
+BIN_CHECK
+    exit 1
+}
+
+
+#------------------------------------------------------------------------------
+# list of directories
+dirList=$(
+    for dir in \
+        $packDir/bin/$archOptions \
+        $packDir/lib/$archOptions \
+        $packDir/applications/bin/$archOptions \
+        $packDir/wmake/bin/$archCompiler \
+        $packDir/wmake/bin/$archOS \
+        $packDir/wmake/rules/General \
+        $packDir/wmake/rules/$archCompiler \
+        $packDir/wmake/rules/$archOS \
+        ;
+    do
+        [ -d $dir ] && echo $dir
+    done
+)
+
+
+cat <<INFO 1>&2
+-------------------------------------------------------------------------------
+Packing $archOptions ($archCompiler) port of $packDir
+    archOS       = $archOS
+    32bit archOS = $arch3264
+
+dirs:
+    $(echo ${dirList:-NONE})
+
+INFO
+
+echo "$dirList"
+
+#------------------------------------------------------------------------------
diff --git a/bin/tools/foamListSourceFiles b/bin/tools/foamListSourceFiles
new file mode 100755
index 0000000000000000000000000000000000000000..81e299c4a15f0d4967785178465ac90a95d836e5
--- /dev/null
+++ b/bin/tools/foamListSourceFiles
@@ -0,0 +1,93 @@
+#!/bin/sh
+#------------------------------------------------------------------------------
+# =========                 |
+# \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
+#  \\    /   O peration     |
+#   \\  /    A nd           | Copyright (C) 1991-2011 OpenCFD Ltd.
+#    \\/     M anipulation  |
+#------------------------------------------------------------------------------
+# License
+#     This file is part of OpenFOAM.
+#
+#     OpenFOAM is free software: you can redistribute it and/or modify it
+#     under the terms of the GNU General Public License as published by
+#     the Free Software Foundation, either version 3 of the License, or
+#     (at your option) any later version.
+#
+#     OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
+#     ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+#     FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+#     for more details.
+#
+#     You should have received a copy of the GNU General Public License
+#     along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.
+#
+# Script
+#     foamListSourceFiles <directory>
+#
+# Description
+#     Lists source files and Make/{files,options} in given directory
+#
+# Note
+#     Not normally called directly by the user.
+#------------------------------------------------------------------------------
+
+[ $# -eq 1 ] || {
+cat <<USAGE 1>&2
+Usage : ${0##*/} directory
+
+* Lists source files and Make/{files,options} in given directory
+
+USAGE
+    exit 1
+}
+
+# canonical form (no double and no trailing dashes)
+packDir=$(echo "$1" | sed -e 's@//*@/@g' -e 's@/$@@')
+
+# check for essential directories
+[ -d $packDir ] || {
+    echo "Error: directory $packDir does not exist" 1>&2
+    exit 1
+}
+
+
+#
+# list of files but excluding
+# - dependent files (dep, obj, lib), archives
+# - exclude Doxygen documentation etc
+#
+
+find -H $packDir                                                              \
+    ! -type d                                                                 \
+   \( -type f -o -type l \)                                                   \
+    ! -name "*~"                                                              \
+ -a ! -name ".*~"                                                             \
+ -a ! -name "*.orig"                                                          \
+ -a ! -name "*.dep"                                                           \
+ -a ! -name "*.o"                                                             \
+ -a ! -name "*.so"                                                            \
+ -a ! -name "*.a"                                                             \
+ -a ! -name "*.tar"                                                           \
+ -a ! -name "*.tar.gz"                                                        \
+ -a ! -name "*.tgz"                                                           \
+ -a ! -name "core"                                                            \
+ -a ! -name "core.[1-9]*"                                                     \
+ -a ! -name "libccmio*"                                                       \
+| sed                                                                         \
+ -e "\@$packDir/lib/@d"                                                       \
+ -e '\@/\.git/@d'                                                             \
+ -e '\@/\.tags/@d'                                                            \
+ -e '\@/README\.org@d'                                                        \
+ -e '\@/bin/[^/]*/@{ \@/bin/tools/@!d }'                                      \
+ -e '\@/lib/@d'                                                               \
+ -e '\@/platforms/@d'                                                         \
+ -e '\@/t/@d'                                                                 \
+ -e '\@/Make[.A-Za-z]*/[^/]*/@d'                                              \
+ -e '\@/[Dd]oxygen/html/@d'                                                   \
+ -e '\@/download/@d'                                                          \
+ -e '\@/libccmio-.*/@d'                                                       \
+ -e '\@/debian/@d'
+
+
+#------------------------------------------------------------------------------
diff --git a/bin/tools/foamListThirdPartyBinDirs b/bin/tools/foamListThirdPartyBinDirs
new file mode 100755
index 0000000000000000000000000000000000000000..319961b944173c234be9971193e8c7af8af066ad
--- /dev/null
+++ b/bin/tools/foamListThirdPartyBinDirs
@@ -0,0 +1,121 @@
+#!/bin/sh
+#------------------------------------------------------------------------------
+# =========                 |
+# \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
+#  \\    /   O peration     |
+#   \\  /    A nd           | Copyright (C) 2011-2011 OpenCFD Ltd.
+#    \\/     M anipulation  |
+#-------------------------------------------------------------------------------
+# License
+#     This file is part of OpenFOAM.
+#
+#     OpenFOAM is free software: you can redistribute it and/or modify it
+#     under the terms of the GNU General Public License as published by
+#     the Free Software Foundation, either version 3 of the License, or
+#     (at your option) any later version.
+#
+#     OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
+#     ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+#     FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+#     for more details.
+#
+#     You should have received a copy of the GNU General Public License
+#     along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.
+#
+# Script
+#     foamListThirdPartyBinDirs <directory> <archOptions>
+#
+# Description
+#     Lists directories containing binary files for OpenFOAM ThirdParty
+#
+# Note
+#     Not normally called directly by the user.
+#------------------------------------------------------------------------------
+toolsDir="${0%/*}"  # this script is already located in the tools/ directory
+
+[ $# -eq 2 ] || {
+cat <<USAGE 1>&2
+Usage : ${0##*/} <packDir> <archOptions>
+
+* List directories containing binary files for OpenFOAM ThirdParty
+
+    The value of 'archOptions' normally corresponds to \$WM_OPTIONS
+    The current value of \$WM_OPTIONS = $WM_OPTIONS
+
+USAGE
+    exit 1
+}
+
+#------------------------------------------------------------------------------
+packDir="$1"
+
+# same as $WM_OPTIONS - eg, 'linux64GccDPOpt'
+archOptions="$2"
+
+# base arch (w/o precision, optimization, etc)
+# same as "$WM_ARCH$WM_COMPILER"
+archCompiler=$(echo "$archOptions" | sed -e 's@[DS]P.*$@@')
+
+# same as $WM_ARCH - eg, 'linux64'
+# TODO: only works for Gcc, Icc, Clang
+archOS=$(echo "$archOptions" | sed -e 's@[GI]cc.*$@@' -e 's@Clang.*$@@')
+
+# links for 32-bit version, eg convert linux64 -> linux-64
+arch3264=$(echo "$archOS" | sed -e 's@64@-64@')
+
+
+#------------------------------------------------------------------------------
+# check for essential directories
+for dir in $packDir $packDir/lib/$archOptions
+do
+    [ -d $dir ] || {
+        echo "Error: directory $dir does not exist" 1>&2
+        exit 1
+    }
+done
+
+#------------------------------------------------------------------------------
+# list of directories
+dirList=$(
+    for dir in \
+        $packDir/bin/$archOptions \
+        $packDir/bin/$archCompiler \
+        $packDir/bin/$archOS \
+        $packDir/lib/$archOptions \
+        $packDir/lib/$archCompiler \
+        $packDir/lib/$archOS \
+        $packDir/platforms/$archOptions \
+        $packDir/platforms/$archCompiler \
+        $packDir/platforms/$archOS \
+        ;
+    do
+        [ -d $dir ] && echo $dir
+    done
+
+    # add in links for 32-bit version
+    if [ "$archOS" != "$arch3264" ]
+    then
+        for dir in \
+            $packDir/platforms/$arch3264 \
+            ;
+        do
+            [ -d $dir -a -L $dir ] && echo $dir
+        done
+     fi
+)
+
+
+cat <<INFO 1>&2
+-------------------------------------------------------------------------------
+Packing $archOptions ($archCompiler) port of $packDir
+    archOS       = $archOS
+    32bit archOS = $arch3264
+
+dirs:
+    $(echo ${dirList:-NONE})
+
+INFO
+
+echo "$dirList"
+
+#------------------------------------------------------------------------------
diff --git a/bin/foamPackSource b/bin/tools/foamPackSource
similarity index 61%
rename from bin/foamPackSource
rename to bin/tools/foamPackSource
index 8305a929a8251208ebcc5a71ce1dcd04a6d7cd10..3f6d547895c2217554343cdcf5da0f0ece3a0ef8 100755
--- a/bin/foamPackSource
+++ b/bin/tools/foamPackSource
@@ -3,7 +3,7 @@
 # =========                 |
 # \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
 #  \\    /   O peration     |
-#   \\  /    A nd           | Copyright (C) 1991-2010 OpenCFD Ltd.
+#   \\  /    A nd           | Copyright (C) 1991-2011 OpenCFD Ltd.
 #    \\/     M anipulation  |
 #-------------------------------------------------------------------------------
 # License
@@ -26,54 +26,67 @@
 #     foamPackSource <directory> <tarFile>
 #
 # Description
-#     Packs and compresses the .C and .H files and Make/options
-#     and Make/files in a given directory.
+#     Pack and compress all source files from a given directory.
 #
+# Note
+#     Not normally called directly by the user
 #------------------------------------------------------------------------------
 tmpFile=${TMPDIR:-/tmp}/foamPackFiles.$$
+toolsDir="${0%/*}"  # this script is already located in the tools/ directory
 
-if [ $# -ne 2 ]
-then
-    echo "Usage : ${0##*/} directory tarFile"
-    echo ""
-    echo "Packs all .C and .H files and Make/options and Make/files into"
-    echo "<tarFile>"
-    echo ""
+[ $# -eq 2 ] || {
+cat <<USAGE 1>&2
+Usage : ${0##*/} directory tarFile
+
+* Pack and compress all source files from a given directory into <tarFile>
+
+USAGE
     exit 1
-fi
+}
 
 # canonical form (no double and no trailing dashes)
 packDir=$(echo "$1" | sed -e 's@//*@/@g' -e 's@/$@@')
 packFile=$2
 
-if [ ! -d $packDir ]
-then
-    echo "Error: directory $packDir does not exist"
+# check for essential directories
+[ -d $packDir ] || {
+    echo "Error: directory $packDir does not exist" 1>&2
     exit 1
-fi
+}
+
 
+# avoid overwriting old pack file
 if [ -f $packFile ]
 then
-    echo "Error: $packFile already exists"
+    echo "Error: $packFile already exists" 1>&2
     exit 1
 fi
 
 # Clean up on termination and on Ctrl-C
 trap 'rm -f $tmpFile 2>/dev/null; exit 0' EXIT TERM INT
 
-foamSourceFiles $packDir > $tmpFile
+# get all names
+$toolsDir/foamListSourceFiles $packDir > $tmpFile
 
 
 # provide some feedback
-wc $tmpFile | awk '{print "Packing",$1,"files - this could take some time ..."}'
+cat <<INFO 1>&2
+-------------------------------------------------------------------------------
+Packing $packDir source files into $packFile
+
+INFO
+wc $tmpFile | awk '{print "Packing",$1,"files - this could take some time ..."}' 1>&2
+
 
-tar czpf $packFile --files-from $tmpFile
+# Clean up on Ctrl-C
+trap 'rm -f $packFile $tmpFile 2>/dev/null' INT
 
+tar cpzf $packFile --files-from $tmpFile
 if [ $? -eq 0 ]
 then
-    echo "Finished packing and compressing $packDir into file $packFile"
+    echo "Finished packing $packDir into file $packFile" 1>&2
 else
-    echo "Error: failure packing $packDir into file $packFile"
+    echo "Error: failure packing $packDir into file $packFile" 1>&2
     rm -f $packFile 2>/dev/null
 fi
 
diff --git a/doc/doxygen/css/doxyTabs.css b/doc/doxygen/css/doxyTabs.css
index 1cc5525827bbbf7270e1e4ede0aa27ab87898613..58f32ccf4127128f36340f18f6e58a9ea0f24a0e 100644
--- a/doc/doxygen/css/doxyTabs.css
+++ b/doc/doxygen/css/doxyTabs.css
@@ -11,7 +11,8 @@ div.navigation
 }
 
 
-div.tabs
+div.tabs,
+div.tabs2
 {
     width           : 100%;
     padding-top     : 5px;
@@ -20,7 +21,8 @@ div.tabs
     border-bottom: 1px solid rgb(175,175,175);
 }
 
-div.tabs ul
+div.tabs ul,
+div.tabs2 ul
 {
     margin: 0px;
     padding-left: 10px;
@@ -30,26 +32,30 @@ div.tabs ul
 }
 
 
-div.tabs li, div.tabs form
+div.tabs li, div.tabs form,
+div.tabs2 li, div.tabs2 form
 {
     display         : inline;
     margin          : 0px;
     padding         : 0px;
 }
 
-div.tabs ul li
+div.tabs ul li,
+div.tabs2 ul li
 {
     padding-top: 10px;
     padding-bottom: 10px;
     height: 100%;
 }
 
-div.tabs form
+div.tabs form,
+div.tabs2 form
 {
     padding         : 0px 9px;
 }
 
-div.tabs a
+div.tabs a,
+div.tabs2 a
 {
     font-size       : 12px;
     font-weight     : normal;
@@ -58,7 +64,8 @@ div.tabs a
 }
 
 /* not needed - no image */
-div.tabs a:hover
+div.tabs a:hover,
+div.tabs2 a:hover
 {
     background-position: 100% -150px;
 }
@@ -66,13 +73,18 @@ div.tabs a:hover
 div.tabs a:link,
 div.tabs a:visited,
 div.tabs a:active,
-div.tabs a:hover
+div.tabs a:hover,
+div.tabs2 a:link,
+div.tabs2 a:visited,
+div.tabs2 a:active,
+div.tabs2 a:hover
 {
     color           : #000000;
     color:#555;
 }
 
-div.tabs span
+div.tabs span,
+div.tabs2 span
 {
     display         : inline;
     padding         : 0px 9px;
@@ -80,7 +92,8 @@ div.tabs span
 }
 
 /* client-side search */
-div.tabs #MSearchBox
+div.tabs #MSearchBox,
+div.tabs2 #MSearchBox
 {
    float            : right;
    background       : white;
@@ -88,7 +101,8 @@ div.tabs #MSearchBox
    font-size        : 1em;
 }
 
-div.tabs #MSearchSelect
+div.tabs #MSearchSelect,
+div.tabs2 #MSearchSelect
 {
    float            : left;
    display          : inline;
@@ -96,14 +110,16 @@ div.tabs #MSearchSelect
 }
 
 /* old name? */
-div.tabs input
+div.tabs input,
+div.tabs2 input
 {
     float           : right;
     display         : inline;
     font-size       : 1em;
 }
 
-div.tabs td
+div.tabs td,
+div.tabs2 td
 {
     font-size       : 80%;
     font-weight     : bold;
@@ -120,14 +136,16 @@ div.tabs a:hover span
     background-position: 0% -150px;
 }
 
-div.tabs li.current a
+div.tabs li.current a,
+div.tabs2 li.current a
 {
     border-width    : 0px;
     border-right: 1px solid rgb(175,175,175);
     color           : #555;
 }
 
-div.tabs li.current span
+div.tabs li.current span,
+div.tabs2 li.current span
 {
     padding-bottom: 0px;
     white-space: nowrap;
diff --git a/etc/codeTemplates/foamScript b/etc/codeTemplates/foamScript
index 57c5f68d4a4197385d6d1e3772d794e2fa6f23a2..21d54cf40019a0d2344d14815e924e711a5c5949 100644
--- a/etc/codeTemplates/foamScript
+++ b/etc/codeTemplates/foamScript
@@ -3,7 +3,7 @@
 # =========                 |
 # \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
 #  \\    /   O peration     |
-#   \\  /    A nd           | Copyright (C) 2010-2010 OpenCFD Ltd.
+#   \\  /    A nd           | Copyright (C) 2011-2011 OpenCFD Ltd.
 #    \\/     M anipulation  |
 #------------------------------------------------------------------------------
 # License
diff --git a/etc/codeTemplates/source/_Template.C b/etc/codeTemplates/source/_Template.C
index ed2b7283afc91975595c8b62adc8876d60973472..150d79e8c037034bc37bab4e21e0ef9c49600b77 100644
--- a/etc/codeTemplates/source/_Template.C
+++ b/etc/codeTemplates/source/_Template.C
@@ -2,7 +2,7 @@
   =========                 |
   \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
    \\    /   O peration     |
-    \\  /    A nd           | Copyright (C) 2010-2010 OpenCFD Ltd.
+    \\  /    A nd           | Copyright (C) 2011-2011 OpenCFD Ltd.
      \\/     M anipulation  |
 -------------------------------------------------------------------------------
 License
diff --git a/etc/codeTemplates/source/_Template.H b/etc/codeTemplates/source/_Template.H
index 14abca0f60f74c0ed53489180442e38a5389b333..f68ec751b1f02c4c4277962e52d9b055b42ae5f8 100644
--- a/etc/codeTemplates/source/_Template.H
+++ b/etc/codeTemplates/source/_Template.H
@@ -2,7 +2,7 @@
   =========                 |
   \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
    \\    /   O peration     |
-    \\  /    A nd           | Copyright (C) 2010-2010 OpenCFD Ltd.
+    \\  /    A nd           | Copyright (C) 2011-2011 OpenCFD Ltd.
      \\/     M anipulation  |
 -------------------------------------------------------------------------------
 License
diff --git a/etc/codeTemplates/source/_TemplateApp.C b/etc/codeTemplates/source/_TemplateApp.C
index 15e857a6fc091318b8d5add11e066f885f5718bd..58e4f4965936470f3688110befcd0f2b589b7da3 100644
--- a/etc/codeTemplates/source/_TemplateApp.C
+++ b/etc/codeTemplates/source/_TemplateApp.C
@@ -2,7 +2,7 @@
   =========                 |
   \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
    \\    /   O peration     |
-    \\  /    A nd           | Copyright (C) 2010-2010 OpenCFD Ltd.
+    \\  /    A nd           | Copyright (C) 2011-2011 OpenCFD Ltd.
      \\/     M anipulation  |
 -------------------------------------------------------------------------------
 License
diff --git a/etc/codeTemplates/source/_TemplateI.H b/etc/codeTemplates/source/_TemplateI.H
index fbe257009724c10b4030ffa1208e8532c5783b40..718179dd651e4b7477295303b00a213c438393b0 100644
--- a/etc/codeTemplates/source/_TemplateI.H
+++ b/etc/codeTemplates/source/_TemplateI.H
@@ -2,7 +2,7 @@
   =========                 |
   \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
    \\    /   O peration     |
-    \\  /    A nd           | Copyright (C) 2010-2010 OpenCFD Ltd.
+    \\  /    A nd           | Copyright (C) 2011-2011 OpenCFD Ltd.
      \\/     M anipulation  |
 -------------------------------------------------------------------------------
 License
diff --git a/etc/codeTemplates/source/_TemplateIO.C b/etc/codeTemplates/source/_TemplateIO.C
index 5ce56619156daf885006e1387119d59cfa6f0e6b..a43b52f8d88ab399569d36624f710875da632ba1 100644
--- a/etc/codeTemplates/source/_TemplateIO.C
+++ b/etc/codeTemplates/source/_TemplateIO.C
@@ -2,7 +2,7 @@
   =========                 |
   \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
    \\    /   O peration     |
-    \\  /    A nd           | Copyright (C) 2010-2010 OpenCFD Ltd.
+    \\  /    A nd           | Copyright (C) 2011-2011 OpenCFD Ltd.
      \\/     M anipulation  |
 -------------------------------------------------------------------------------
 License
diff --git a/etc/codeTemplates/template/_TemplateTemplate.C b/etc/codeTemplates/template/_TemplateTemplate.C
index 712ac72122b2480ef04ab07a120f4b811821f7bc..6627c3ac140a25e943c4939fd4387267eb5f5547 100644
--- a/etc/codeTemplates/template/_TemplateTemplate.C
+++ b/etc/codeTemplates/template/_TemplateTemplate.C
@@ -2,7 +2,7 @@
   =========                 |
   \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
    \\    /   O peration     |
-    \\  /    A nd           | Copyright (C) 2010-2010 OpenCFD Ltd.
+    \\  /    A nd           | Copyright (C) 2011-2011 OpenCFD Ltd.
      \\/     M anipulation  |
 -------------------------------------------------------------------------------
 License
diff --git a/etc/codeTemplates/template/_TemplateTemplate.H b/etc/codeTemplates/template/_TemplateTemplate.H
index fca7e2722c949d46661c07b423473b3f91a5c130..52aa72647bdcc8305aabff1ee5e9be3a18e8aec3 100644
--- a/etc/codeTemplates/template/_TemplateTemplate.H
+++ b/etc/codeTemplates/template/_TemplateTemplate.H
@@ -2,7 +2,7 @@
   =========                 |
   \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
    \\    /   O peration     |
-    \\  /    A nd           | Copyright (C) 2010-2010 OpenCFD Ltd.
+    \\  /    A nd           | Copyright (C) 2011-2011 OpenCFD Ltd.
      \\/     M anipulation  |
 -------------------------------------------------------------------------------
 License
diff --git a/etc/codeTemplates/template/_TemplateTemplateI.H b/etc/codeTemplates/template/_TemplateTemplateI.H
index fbe257009724c10b4030ffa1208e8532c5783b40..718179dd651e4b7477295303b00a213c438393b0 100644
--- a/etc/codeTemplates/template/_TemplateTemplateI.H
+++ b/etc/codeTemplates/template/_TemplateTemplateI.H
@@ -2,7 +2,7 @@
   =========                 |
   \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
    \\    /   O peration     |
-    \\  /    A nd           | Copyright (C) 2010-2010 OpenCFD Ltd.
+    \\  /    A nd           | Copyright (C) 2011-2011 OpenCFD Ltd.
      \\/     M anipulation  |
 -------------------------------------------------------------------------------
 License
diff --git a/etc/codeTemplates/template/_TemplateTemplateIO.C b/etc/codeTemplates/template/_TemplateTemplateIO.C
index 7da36ef885f3bb096fccf0667fe92d51c9c292d8..f1ed4c1b6ac8952b14643b3a57b2e87167661193 100644
--- a/etc/codeTemplates/template/_TemplateTemplateIO.C
+++ b/etc/codeTemplates/template/_TemplateTemplateIO.C
@@ -2,7 +2,7 @@
   =========                 |
   \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
    \\    /   O peration     |
-    \\  /    A nd           | Copyright (C) 2010-2010 OpenCFD Ltd.
+    \\  /    A nd           | Copyright (C) 2011-2011 OpenCFD Ltd.
      \\/     M anipulation  |
 -------------------------------------------------------------------------------
 License
diff --git a/tutorials/basic/laplacianFoam/flange/Allrun b/tutorials/basic/laplacianFoam/flange/Allrun
index db939bed7645b3812ce61fd4ebb7fee6583da63a..be6367359fa3d23372d731a4ac414e0e23d0d7b9 100755
--- a/tutorials/basic/laplacianFoam/flange/Allrun
+++ b/tutorials/basic/laplacianFoam/flange/Allrun
@@ -11,7 +11,7 @@ runAnsysToFoam()
 {
     if [ -f log.ansysToFoam ]
     then
-        echo "ansysToFoam already run on $PWD: remove log file to run"
+        echo "ansysToFoam already run on $PWD: remove log file to re-run"
     else
         echo "ansysToFoam: converting mesh $1"
         ansysToFoam $1 -scale $2 > log.ansysToFoam 2>&1
diff --git a/tutorials/combustion/engineFoam/kivaTest/Allrun b/tutorials/combustion/engineFoam/kivaTest/Allrun
index 6c86823f996c3269898909f9293e0fe0e04246b8..21d4983a9393d8df2e99d3d20096d0a2578905a6 100755
--- a/tutorials/combustion/engineFoam/kivaTest/Allrun
+++ b/tutorials/combustion/engineFoam/kivaTest/Allrun
@@ -11,7 +11,7 @@ runKivaToFoam()
 {
     if [ -f log.kivaToFoam ]
     then
-        echo "kivaToFoam already run: remove log file to run"
+        echo "kivaToFoam already run: remove log file to re-run"
     else
         echo "kivaToFoam: converting kiva file"
         kivaToFoam -file $1 > log.kivaToFoam 2>&1
@@ -23,7 +23,7 @@ restartApplication()
 {
     if [ -f log-2.$1 ]
     then
-        echo "$1 already run: remove log file to run"
+        echo "$1 already run: remove log file to re-run"
     else
         echo "Running $1"
         $1 > log-2.$1 2>&1
diff --git a/tutorials/compressible/sonicFoam/ras/nacaAirfoil/Allrun b/tutorials/compressible/sonicFoam/ras/nacaAirfoil/Allrun
index 03afe0bd219d83c3efc636280b831332ac8ad9b6..6142b9557c81a05d64dd43de4b095a5d0b21493f 100755
--- a/tutorials/compressible/sonicFoam/ras/nacaAirfoil/Allrun
+++ b/tutorials/compressible/sonicFoam/ras/nacaAirfoil/Allrun
@@ -11,7 +11,7 @@ runStarToFoam()
 {
     if [ -f log.star3ToFoam -o -f log.starToFoam ]
     then
-        echo "star3ToFoam already run on $PWD: remove log file to run"
+        echo "star3ToFoam already run on $PWD: remove log file to re-run"
     else
         echo "star3ToFoam: converting mesh $1"
         star3ToFoam $1 > log.star3ToFoam 2>&1